var NAVTREE =
[
  [ "CGAL 4.8.1 - Manual", "index.html", [
    [ "Getting Started", "general_intro.html", "general_intro" ],
    [ "Package Overview", "packages.html", [
      [ "Arithmetic and Algebra", "packages.html#PartAlgebraicFoundations", [
        [ "Algebraic Foundations", "packages.html#PkgAlgebraicFoundationsSummary", null ],
        [ "Number Types", "packages.html#PkgNumberTypesSummary", null ],
        [ "Modular Arithmetic", "packages.html#PkgModularArithmeticSummary", null ],
        [ "Polynomial", "packages.html#PkgPolynomialSummary", null ],
        [ "Algebraic Kernel", "packages.html#PkgAlgebraicKerneldSummary", null ]
      ] ],
      [ "Combinatorial Algorithms", "packages.html#PartCombinatorialAlgorithms", [
        [ "Monotone and Sorted Matrix Search", "packages.html#PkgMatrixSearchSummary", null ],
        [ "Linear and Quadratic Programming Solver", "packages.html#PkgQPSolverSummary", null ]
      ] ],
      [ "Geometry Kernels", "packages.html#PartKernels", [
        [ "2D and 3D Linear Geometry Kernel", "packages.html#PkgKernel23Summary", null ],
        [ "dD Geometry Kernel", "packages.html#PkgKernelDSummary", null ],
        [ "2D Circular Geometry Kernel", "packages.html#PkgCircularKernel2Summary", null ],
        [ "3D Spherical Geometry Kernel", "packages.html#PkgSphericalKernel3Summary", null ]
      ] ],
      [ "Convex Hull Algorithms", "packages.html#PartConvexHullAlgorithms", [
        [ "2D Convex Hulls and Extreme Points", "packages.html#PkgConvexHull2Summary", null ],
        [ "3D Convex Hulls", "packages.html#PkgConvexHull3Summary", null ],
        [ "dD Convex Hulls and Delaunay Triangulations", "packages.html#PkgConvexHullDSummary", null ]
      ] ],
      [ "Polygons", "packages.html#PartPolygons", [
        [ "2D Polygons", "packages.html#PkgPolygon2Summary", null ],
        [ "2D Regularized Boolean Set-Operations", "packages.html#PkgBooleanSetOperations2Summary", null ],
        [ "2D Boolean Operations on Nef Polygons", "packages.html#PkgNef2Summary", null ],
        [ "2D Boolean Operations on Nef Polygons Embedded on the Sphere", "packages.html#PkgNefS2Summary", null ],
        [ "2D Polygon Partitioning", "packages.html#PkgPolygonPartitioning2Summary", null ],
        [ "2D Straight Skeleton and Polygon Offsetting", "packages.html#PkgStraightSkeleton2Summary", null ],
        [ "2D Minkowski Sums", "packages.html#PkgMinkowskiSum2Summary", null ],
        [ "2D Polyline Simplification", "packages.html#PkgPolylineSimplification2Summary", null ],
        [ "2D Visibility Computation", "packages.html#PkgVisibility_2Summary", null ]
      ] ],
      [ "Cell Complexes and Polyhedra", "packages.html#PartPolyhedra", [
        [ "3D Polyhedral Surface", "packages.html#PkgPolyhedronSummary", null ],
        [ "Halfedge Data Structures", "packages.html#PkgHDSSummary", null ],
        [ "Surface Mesh", "packages.html#PkgSurfaceMeshSummary", null ],
        [ "Combinatorial Maps", "packages.html#PkgCombinatorialMapsSummary", null ],
        [ "Linear Cell Complex", "packages.html#PkgLinearCellComplexSummary", null ],
        [ "3D Boolean Operations on Nef Polyhedra", "packages.html#PkgNef3Summary", null ],
        [ "Convex Decomposition of Polyhedra", "packages.html#PkgConvexDecomposition3Summary", null ],
        [ "3D Minkowski Sum of Polyhedra", "packages.html#PkgMinkowskiSum3Summary", null ]
      ] ],
      [ "Arrangements", "packages.html#PartArrangements", [
        [ "2D Arrangements", "packages.html#PkgArrangement2Summary", null ],
        [ "2D Intersection of Curves", "packages.html#PkgIntersectionOfCurves2Summary", null ],
        [ "2D Snap Rounding", "packages.html#PkgSnapRounding2Summary", null ],
        [ "2D Envelopes", "packages.html#PkgEnvelope2Summary", null ],
        [ "3D Envelopes", "packages.html#PkgEnvelope3Summary", null ]
      ] ],
      [ "Triangulations and Delaunay Triangulations", "packages.html#PartTriangulationsAndDelaunayTriangulations", [
        [ "2D Triangulation", "packages.html#PkgTriangulation2Summary", null ],
        [ "2D Triangulation Data Structure", "packages.html#PkgTDS2Summary", null ],
        [ "2D Periodic Triangulations", "packages.html#PkgPeriodic2Triangulation2Summary", null ],
        [ "3D Triangulations", "packages.html#PkgTriangulation3Summary", null ],
        [ "3D Triangulation Data Structure", "packages.html#PkgTDS3Summary", null ],
        [ "3D Periodic Triangulations", "packages.html#PkgPeriodic3Triangulation3Summary", null ],
        [ "dD Triangulations", "packages.html#PkgTriangulationsSummary", null ],
        [ "2D Alpha Shapes", "packages.html#PkgAlphaShape2Summary", null ],
        [ "3D Alpha Shapes", "packages.html#PkgAlphaShapes3Summary", null ]
      ] ],
      [ "Voronoi Diagrams", "packages.html#PartVoronoiDiagrams", [
        [ "2D Segment Delaunay Graphs", "packages.html#PkgSegmentDelaunayGraph2Summary", null ],
        [ "L Infinity Segment Delaunay Graphs", "packages.html#PkgSDGLinfSummary", null ],
        [ "2D Apollonius Graphs (Delaunay Graphs of Disks)", "packages.html#PkgApolloniusGraph2Summary", null ],
        [ "2D Voronoi Diagram Adaptor", "packages.html#PkgVoronoiDiagramAdaptor2Summary", null ]
      ] ],
      [ "Mesh Generation", "packages.html#PartMeshing", [
        [ "2D Conforming Triangulations and Meshes", "packages.html#PkgMesh2Summary", null ],
        [ "3D Surface Mesh Generation", "packages.html#PkgSurfaceMesher3Summary", null ],
        [ "3D Skin Surface Meshing", "packages.html#PkgSkinSurface3Summary", null ],
        [ "3D Mesh Generation", "packages.html#PkgMesh_3Summary", null ]
      ] ],
      [ "Shape Reconstruction", "packages.html#PartReconstruction", [
        [ "Poisson Surface Reconstruction", "packages.html#PkgPoissonSurfaceReconstructionSummary", null ],
        [ "Scale-Space Surface Reconstruction", "packages.html#PkgScaleSpaceReconstruction3Summary", null ],
        [ "Advancing Front Surface Reconstruction", "packages.html#PkgAdvancingFrontSurfaceReconstructionSummary", null ],
        [ "Optimal Transportation Curve Reconstruction", "packages.html#PkgOptimalTransportationReconstruction2Summary", null ]
      ] ],
      [ "Geometry Processing", "packages.html#PartGeometryProcessing", [
        [ "Polygon Mesh Processing", "packages.html#PkgPolygonMeshProcessingSummary", null ],
        [ "3D Surface Subdivision Methods", "packages.html#PkgSurfaceSubdivisionMethods3Summary", null ],
        [ "Triangulated Surface Mesh Segmentation", "packages.html#PkgSurfaceSegmentationSummary", null ],
        [ "Triangulated Surface Mesh Simplification", "packages.html#PkgSurfaceMeshSimplificationSummary", null ],
        [ "Triangulated Surface Mesh Deformation", "packages.html#PkgSurfaceMeshDeformationSummary", null ],
        [ "Triangulated Surface Mesh Parameterization", "packages.html#PkgSurfaceParameterizationSummary", null ],
        [ "Triangulated Surface Mesh Shortest Paths", "packages.html#PkgSurfaceMeshShortestPathSummary", null ],
        [ "Triangulated Surface Mesh Skeletonization", "packages.html#PkgMeanCurvatureSkeleton3Summary", null ],
        [ "Approximation of Ridges and Umbilics on Triangulated Surface Meshes", "packages.html#PkgRidges_3Summary", null ],
        [ "Estimation of Local Differential Properties of Point-Sampled Surfaces", "packages.html#PkgJet_fitting_3Summary", null ],
        [ "Point Set Processing", "packages.html#PkgPointSetProcessingSummary", null ],
        [ "Point Set Shape Detection", "packages.html#PkgPointSetShapeDetection3Summary", null ],
        [ "2D Placement of Streamlines", "packages.html#PkgPlacementOfStreamlines2Summary", null ]
      ] ],
      [ "Spatial Searching and Sorting", "packages.html#PartSearchStructures", [
        [ "2D Range and Neighbor Search", "packages.html#PkgPointSet2Summary", null ],
        [ "Interval Skip List", "packages.html#PkgIntervalSkipListSummary", null ],
        [ "dD Spatial Searching", "packages.html#PkgSpatialSearchingDSummary", null ],
        [ "dD Range and Segment Trees", "packages.html#PkgRangeSegmentTreesDSummary", null ],
        [ "Intersecting Sequences of dD Iso-oriented Boxes", "packages.html#PkgBoxIntersectionDSummary", null ],
        [ "3D Fast Intersection and Distance Computation", "packages.html#PkgAABB_treeSummary", null ],
        [ "Spatial Sorting", "packages.html#PkgSpatialSortingSummary", null ]
      ] ],
      [ "Geometric Optimization", "packages.html#PartGeometricOptimization", [
        [ "Bounding Volumes", "packages.html#PkgBoundingVolumesSummary", null ],
        [ "Inscribed Areas", "packages.html#PkgInscribedAreasSummary", null ],
        [ "Optimal Distances", "packages.html#PkgOptimalDistancesSummary", null ],
        [ "Principal Component Analysis", "packages.html#PkgPrincipalComponentAnalysisDSummary", null ]
      ] ],
      [ "Interpolation", "packages.html#PartInterpolation", [
        [ "2D and Surface Function Interpolation", "packages.html#PkgInterpolation2Summary", null ],
        [ "2D Generalized Barycentric Coordinates", "packages.html#PkgBarycentric_coordinates_2Summary", null ]
      ] ],
      [ "Kinetic Data Structures", "packages.html#PartKineticDataStructures", [
        [ "Kinetic Data Structures", "packages.html#PkgKdsSummary", null ],
        [ "Kinetic Framework", "packages.html#PkgKdsFrameworkSummary", null ]
      ] ],
      [ "Support Library", "packages.html#PartSupportLibrary", [
        [ "STL Extensions for CGAL", "packages.html#PkgStlExtensionSummary", null ],
        [ "CGAL and the Boost Graph Library", "packages.html#PkgBGLSummary", null ],
        [ "CGAL and Solvers", "packages.html#PkgSolverSummary", null ],
        [ "CGAL and Boost Property Maps", "packages.html#PkgProperty_mapSummary", null ],
        [ "Handles and Circulators", "packages.html#PkgHandlesAndCirculatorsSummary", null ],
        [ "Geometric Object Generators", "packages.html#PkgGeneratorsSummary", null ],
        [ "Profiling tools, Hash Map, Union-find, Modifiers", "packages.html#PkgProfilingToolsSummary", null ],
        [ "IO Streams", "packages.html#PkgIOstreamsSummary", null ]
      ] ],
      [ "Visualization", "packages.html#PartVisualization", [
        [ "Geomview", "packages.html#PkgGeomviewSummary", null ],
        [ "CGAL and the Qt Graphics View Framework", "packages.html#PkgGraphicsViewSummary", null ],
        [ "CGAL Ipelets", "packages.html#PkgCGALIpeletsSummary", null ]
      ] ]
    ] ],
    [ "Developer Manual", "dev_manual.html", "dev_manual" ],
    [ "Acknowledging CGAL", "how_to_cite_cgal.html", null ],
    [ "Bibliographic References", "citelist.html", null ],
    [ "Class and Concept List", "annotated.html", "annotated" ]
  ] ]
];

var NAVTREEINDEX =
[
".html",
"classAlgebraicKernel__d__1_1_1Compare__1.html#a723e326f6edc7a128e5a227d4aafc3b3",
"classAlphaShapeCell__3.html#ad2a7b5def6e0c47c26453d0c74854671",
"classArrangementDcelHalfedge.html#afbc78a66a76118c05654517b78f4b2bb",
"classBisectionGeometricTraits__3.html#aa92c4fb0722e3743b3e4e430e02480cd",
"classCGAL_1_1Alpha__shape__3.html",
"classCGAL_1_1Arr__Bezier__curve__traits__2_1_1Point__2.html",
"classCGAL_1_1Arr__linear__traits__2_1_1Curve__2.html#ab3d427f701e59c27a0286b5613b8d464",
"classCGAL_1_1Arr__rational__function__traits__2_1_1Curve__2.html#a67105d9dc40a1597fc45236e6c5f9143",
"classCGAL_1_1CatmullClark__mask__3.html#aea515e190b7b02ae57a2863f56dad263",
"classCGAL_1_1Concurrent__compact__container.html#a45c8b8c2865569fc7fc0cd94962db5d1",
"classCGAL_1_1Convex__hull__d.html#ad315ca5f623ae8a5b4d16b665f4ea7c8",
"classCGAL_1_1Delaunay__triangulation__2.html#ad4b4e9423867399e922285de5eb826c8",
"classCGAL_1_1Euclidean__distance__sphere__point.html#aabc7c62f18c9ed705a8b6657e2f7e448",
"classCGAL_1_1General__polygon__set__2.html#abce804d687c42bdf257e894ac3736c51",
"classCGAL_1_1HalfedgeDS__decorator.html#a1b69fcdaeb8f93d0541025c3d2151746",
"classCGAL_1_1In__place__list.html#a95b913172ca02a5b6173a5774fea1bdb",
"classCGAL_1_1Join__input__iterator__2.html",
"classCGAL_1_1Linear__cell__complex.html#a0ccd106ac9375b37085766b58fbd1cf7",
"classCGAL_1_1Min__circle__2.html#abcadaad1ee98dd749e0b2764bfb31892",
"classCGAL_1_1Modular__traits.html",
"classCGAL_1_1Nef__polyhedron__3.html#a920bdebd6aefeb600daa24932d87955f",
"classCGAL_1_1Nef__polyhedron__S2_1_1SVertex.html#a9feaee288604b73c630eb6f0deec31ed",
"classCGAL_1_1Periodic__2__Delaunay__triangulation__2.html#ad7f5bbc6c3fb4da381d1a42d8995ef0b",
"classCGAL_1_1Periodic__3__triangulation__3.html#a576db27be55a4d04f50f5b9fe46dcb3f",
"classCGAL_1_1Point__2.html#a954519dc0242faa942a1e60c73e22c7c",
"classCGAL_1_1Polyhedron__3.html#a62241505a5199ec963acd2a6fda4239f",
"classCGAL_1_1Polytope__distance__d.html#aa42beef680a3a8ecd6c892275afe05c7",
"classCGAL_1_1Quotient.html#a5ba35aa6cdba180289f133f24f07f5a7",
"classCGAL_1_1Rectangular__p__center__default__traits__2.html#a2ff61027152b6a9b7c07155ea5d0f4af",
"classCGAL_1_1Search__traits.html#a818ea0a6bc7a1d318b61be743c96ac63",
"classCGAL_1_1Segment__d.html#a40ec6b9372ceb0656cff1e2fa96bdaa1",
"classCGAL_1_1Square__border__uniform__parameterizer__3.html",
"classCGAL_1_1Tetrahedron__3.html#abd3cfc6716cd0bf1b1174f84584b0b83",
"classCGAL_1_1Triangulation__2.html#a1788d6ffa3f5986b2b07e7e0b48a2ffc",
"classCGAL_1_1Triangulation__3.html#a4e524b1834176c5c37061f54dadf8292",
"classCGAL_1_1Triangulation__3.html#ad3bc80270d803b67490836a6ed6a336c",
"classCGAL_1_1Triple.html#a5df66d6c889c53621f462ec6c529dd74",
"classCGAL_1_1Voronoi__diagram__2.html#a03ffad9d5d9f0f19f3065df5da97002a",
"classCellAttribute.html#a5ac60b3b000bf21eb0b4e205b97d6250",
"classCombinatorialMap.html#a9a2debbbfe70b829bf016ad0b71a5b1a",
"classDelaunayGraph__2.html#a6dc7746abbd7e247973b91734b7ce754",
"classEnvelopeDiagramEdge.html#abc5d58399ce7057e4a556b37160ea728",
"classGeneralPolygonWithHoles__2.html#ad45a0eacf663f6c4d21ef464691d0d2a",
"classInterpolationTraits.html#ae9d033c8b293fc166505416592f1d2c7",
"classKernel.html#acd069e934f26d01bbe9a7ea26ae7c1d0",
"classKernel_1_1ComputeHy__3.html#a7ce1a379d91106a8b1fe53344c849ff5",
"classKernel_1_1ConstructOppositeVector__3.html",
"classKernel_1_1IsDegenerate__3.html",
"classLinearAlgebraTraits__d.html",
"classMeshDomainWithFeatures__3.html#a465b233a0bb38ae0113b452b8c1f127e",
"classOutputIterator.html",
"classPeriodic__3TriangulationTraits__3.html#af34ccfe6bcd8a21e6b4cdca3150d8210",
"classPolynomialTraits__d_1_1PolynomialSubresultantsWithCofactors.html#ac1ee5fe7cfc768528906e5f680746a17",
"classRegularTriangulationTraits__2.html#a32c443ab42c3b6b74048f2c78ac1451a",
"classSnapRoundingTraits__2.html#afe9c36e6e494472738a890a019b84ffb",
"classSphericalKernel_1_1HasOnUnboundedSide__3.html",
"classSurfaceMeshTriangulation__3.html#a25476b8e093b1d7080f255a5defa659b",
"classTriangulationDataStructure_1_1FullCell.html#a349132871d005bd2af491a5a633018d6",
"classTriangulationDataStructure__3_1_1Cell.html#a267574d573a63aa38023b7182debb301",
"devman_code_format.html#Developer_manualGPLversion",
"packages.html#PkgNef3Summary"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  var imgNode = document.createElement("img");
  imgNode.style.paddingLeft=(16*level).toString()+'px';
  imgNode.width  = 16;
  imgNode.height = 22;
  imgNode.border = 0;
  if (node.childrenData) {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    imgNode.src = node.relpath+"ftv2node.png";
    domNode.appendChild(imgNode);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).show();
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  navTo(o,toroot,window.location.hash,relpath);

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })

  $(window).load(showRoot);
}

